## sparse 0.4.1

=== Makefile ===
VERSION=0.4.1

OS ?= linux

CC ?= gcc
CFLAGS ?= -O2 -finline-functions -fno-strict-aliasing -g
CFLAGS += -Wall -Wwrite-strings
LDFLAGS ?= -g
AR ?= ar

HAVE_LIBXML=$(shell pkg-config --exists libxml-2.0 && echo 'yes')

#
# For debugging, uncomment the next one
#
CFLAGS += -DDEBUG

DESTDIR=
PREFIX=$(HOME)
BINDIR=$(PREFIX)/bin
LIBDIR=$(PREFIX)/lib
MANDIR=$(PREFIX)/share/man
MAN1DIR=$(MANDIR)/man1
INCLUDEDIR=$(PREFIX)/include
PKGCONFIGDIR=$(LIBDIR)/pkgconfig

PROGRAMS=test-lexing test-parsing obfuscate compile graph sparse test-linearize example \
	 test-unssa test-dissect ctags


INST_PROGRAMS=sparse cgcc
INST_MAN1=sparse.1 cgcc.1

ifeq ($(HAVE_LIBXML),yes)
PROGRAMS+=c2xml
INST_PROGRAMS+=c2xml
endif

LIB_H=    token.h parse.h lib.h symbol.h scope.h expression.h target.h \
	  linearize.h bitmap.h ident-list.h compat.h flow.h allocate.h \
	  storage.h ptrlist.h dissect.h

LIB_OBJS= target.o parse.o tokenize.o pre-process.o symbol.o lib.o scope.o \
	  expression.o show-parse.o evaluate.o expand.o inline.o linearize.o \
	  sort.o allocate.o compat-$(OS).o ptrlist.o \
	  flow.o cse.o simplify.o memops.o liveness.o storage.o unssa.o dissect.o

LIB_FILE= libsparse.a
SLIB_FILE= libsparse.so

# If you add $(SLIB_FILE) to this, you also need to add -fpic to CFLAGS above.
# Doing so incurs a noticeable performance hit, and Sparse does not have a
# stable shared library interface, so this does not occur by default.  If you
# really want a shared library, you may want to build Sparse twice: once
# without -fpic to get all the Sparse tools, and again with -fpic to get the
# shared library.
LIBS=$(LIB_FILE)

#
# Pretty print
#
V	      = @
Q	      = $(V:1=)
QUIET_CC      = $(Q:@=@echo    '     CC       '$@;)
QUIET_AR      = $(Q:@=@echo    '     AR       '$@;)
QUIET_GEN     = $(Q:@=@echo    '     GEN      '$@;)
QUIET_LINK    = $(Q:@=@echo    '     LINK     '$@;)
# We rely on the -v switch of install to print 'file -> $install_dir/file'
QUIET_INST_SH = $(Q:@=echo -n  '     INSTALL  ';)
QUIET_INST    = $(Q:@=@echo -n '     INSTALL  ';)

all: $(PROGRAMS) sparse.pc

install: $(INST_PROGRAMS) $(LIBS) $(LIB_H) sparse.pc
	$(Q)install -d $(DESTDIR)$(BINDIR)
	$(Q)install -d $(DESTDIR)$(LIBDIR)
	$(Q)install -d $(DESTDIR)$(MAN1DIR)
	$(Q)install -d $(DESTDIR)$(INCLUDEDIR)/sparse
	$(Q)install -d $(DESTDIR)$(PKGCONFIGDIR)
	$(Q)for f in $(INST_PROGRAMS); do \
		$(QUIET_INST_SH)install -v $$f $(DESTDIR)$(BINDIR)/$$f || exit 1; \
	done
	$(Q)for f in $(INST_MAN1); do \
		$(QUIET_INST_SH)install -m 644 -v $$f $(DESTDIR)$(MAN1DIR)/$$f || exit 1; \
	done
	$(Q)for f in $(LIBS); do \
		$(QUIET_INST_SH)install -m 644 -v $$f $(DESTDIR)$(LIBDIR)/$$f || exit 1; \
	done
	$(Q)for f in $(LIB_H); do \
		$(QUIET_INST_SH)install -m 644 -v $$f $(DESTDIR)$(INCLUDEDIR)/sparse/$$f || exit 1; \
	done
	$(QUIET_INST)install -m 644 -v sparse.pc $(DESTDIR)$(PKGCONFIGDIR)/sparse.pc

sparse.pc: sparse.pc.in
	$(QUIET_GEN)sed 's|@version@|$(VERSION)|g;s|@prefix@|$(PREFIX)|g;s|@libdir@|$(LIBDIR)|g;s|@includedir@|$(INCLUDEDIR)|g' sparse.pc.in > sparse.pc

test-lexing: test-lexing.o $(LIBS)
	$(QUIET_LINK)$(CC) $(LDFLAGS) -o $@ $< $(LIBS)

test-parsing: test-parsing.o $(LIBS)
	$(QUIET_LINK)$(CC) $(LDFLAGS) -o $@ $< $(LIBS)

test-linearize: test-linearize.o $(LIBS)
	$(QUIET_LINK)$(CC) $(LDFLAGS) -o $@ $< $(LIBS)

test-sort: test-sort.o $(LIBS)
	$(QUIET_LINK)$(CC) $(LDFLAGS) -o $@ $< $(LIBS)

compile: compile.o compile-i386.o $(LIBS)
	$(QUIET_LINK)$(CC) $(LDFLAGS) -o $@ $< compile-i386.o $(LIBS)

obfuscate: obfuscate.o $(LIBS)
	$(QUIET_LINK)$(CC) $(LDFLAGS) -o $@ $< $(LIBS)

sparse: sparse.o $(LIBS)
	$(QUIET_LINK)$(CC) $(LDFLAGS) -o $@ $< $(LIBS)

graph: graph.o $(LIBS)
	$(QUIET_LINK)$(CC) $(LDFLAGS) -o $@ $< $(LIBS)

example: example.o $(LIBS)
	$(QUIET_LINK)$(CC) $(LDFLAGS) -o $@ $< $(LIBS)

test-unssa: test-unssa.o $(LIBS)
	$(QUIET_LINK)$(CC) $(LDFLAGS) -o $@ $< $(LIBS)

test-dissect: test-dissect.o $(LIBS)
	$(QUIET_LINK)$(CC) $(LDFLAGS) -o $@ $< $(LIBS)

ctags: ctags.o $(LIBS)
	$(QUIET_LINK)$(CC) $(LDFLAGS) -o $@ $< $(LIBS)

c2xml: c2xml.o $(LIBS)
	$(QUIET_LINK)$(CC) $(LDFLAGS)  -o $@ $< $(LIBS) `pkg-config --libs libxml-2.0`

$(LIB_FILE): $(LIB_OBJS)
	$(QUIET_AR)$(AR) rcs $@ $(LIB_OBJS)

$(SLIB_FILE): $(LIB_OBJS)
	$(QUIET_LINK)$(CC) $(LDFLAGS) -Wl,-soname,$@ -shared -o $@ $(LIB_OBJS)

evaluate.o: $(LIB_H)
expression.o: $(LIB_H)
lib.o: $(LIB_H)
allocate.o: $(LIB_H)
ptrlist.o: $(LIB_H)
parse.o: $(LIB_H)
pre-process.o: $(LIB_H) pre-process.h
scope.o: $(LIB_H)
show-parse.o: $(LIB_H)
symbol.o: $(LIB_H)
expand.o: $(LIB_H)
linearize.o: $(LIB_H)
flow.o: $(LIB_H)
cse.o: $(LIB_H)
simplify.o: $(LIB_H)
memops.o: $(LIB_H)
liveness.o: $(LIB_H)
sort.o: $(LIB_H)
inline.o: $(LIB_H)
target.o: $(LIB_H)
test-lexing.o: $(LIB_H)
test-parsing.o: $(LIB_H)
test-linearize.o: $(LIB_H)
test-dissect.o: $(LIB_H)
test-unssa.o: $(LIB_H)
ctags.o: $(LIB_H)
compile.o: $(LIB_H) compile.h
compile-i386.o: $(LIB_H) compile.h
tokenize.o: $(LIB_H)
sparse.o: $(LIB_H)
obfuscate.o: $(LIB_H)
example.o: $(LIB_H)
storage.o: $(LIB_H)
dissect.o: $(LIB_H)
graph.o: $(LIB_H)

c2xml.o: c2xml.c $(LIB_H)
	$(QUIET_CC)$(CC) `pkg-config --cflags libxml-2.0` -o $@ -c $(CFLAGS) $<

compat-linux.o: compat/strtold.c compat/mmap-blob.c \
	$(LIB_H)
compat-solaris.o: compat/mmap-blob.c $(LIB_H)
compat-mingw.o: $(LIB_H)
compat-cygwin.o: $(LIB_H)

pre-process.h:
	$(QUIET_GEN)echo "#define GCC_INTERNAL_INCLUDE \"`$(CC) -print-file-name=include`\"" > pre-process.h

.c.o:
	$(QUIET_CC)$(CC) -o $@ -c $(CFLAGS) $<

clean: clean-check
	rm -f *.[oa] $(PROGRAMS) $(SLIB_FILE) pre-process.h sparse.pc

dist:
	@if test "`git describe`" != "$(VERSION)" ; then \
		echo 'Update VERSION in the Makefile before running "make dist".' ; \
		exit 1 ; \
	fi
	git archive --format=tar --prefix=sparse-$(VERSION)/ HEAD^{tree} | gzip -9 > sparse-$(VERSION).tar.gz

check: all
	$(Q)cd validation && ./test-suite

clean-check:
	find validation/ \( -name "*.c.output.expected" \
	                 -o -name "*.c.output.got" \
	                 -o -name "*.c.output.diff" \
	                 -o -name "*.c.error.expected" \
	                 -o -name "*.c.error.got" \
	                 -o -name "*.c.error.diff" \
	                 \) -exec rm {} \;

## sparse 0.4.1+git20081218

=== Makefile ===
--- 
+++ 
@@ -1,19 +1,23 @@
 VERSION=0.4.1
 
-OS ?= linux
-
-CC ?= gcc
-CFLAGS ?= -O2 -finline-functions -fno-strict-aliasing -g
+OS = linux
+
+
+CC = gcc
+CFLAGS = -O2 -finline-functions -fno-strict-aliasing -g
 CFLAGS += -Wall -Wwrite-strings
-LDFLAGS ?= -g
-AR ?= ar
+LDFLAGS += -g
+AR = ar
+
+#
+# For debugging, uncomment the next one
+#
+#CFLAGS += -O0 -DDEBUG -g3 -gdwarf-2
 
 HAVE_LIBXML=$(shell pkg-config --exists libxml-2.0 && echo 'yes')
 
-#
-# For debugging, uncomment the next one
-#
-CFLAGS += -DDEBUG
+
+CFLAGS += -DGCC_BASE=\"$(shell $(CC) --print-file-name=)\"
 
 DESTDIR=
 PREFIX=$(HOME)
@@ -145,7 +149,7 @@
 allocate.o: $(LIB_H)
 ptrlist.o: $(LIB_H)
 parse.o: $(LIB_H)
-pre-process.o: $(LIB_H) pre-process.h
+pre-process.o: $(LIB_H)
 scope.o: $(LIB_H)
 show-parse.o: $(LIB_H)
 symbol.o: $(LIB_H)
@@ -184,14 +188,11 @@
 compat-mingw.o: $(LIB_H)
 compat-cygwin.o: $(LIB_H)
 
-pre-process.h:
-	$(QUIET_GEN)echo "#define GCC_INTERNAL_INCLUDE \"`$(CC) -print-file-name=include`\"" > pre-process.h
-
 .c.o:
 	$(QUIET_CC)$(CC) -o $@ -c $(CFLAGS) $<
 
 clean: clean-check
-	rm -f *.[oa] $(PROGRAMS) $(SLIB_FILE) pre-process.h sparse.pc
+	rm -f *.[oa] *.so $(PROGRAMS) $(SLIB_FILE) pre-process.h sparse.pc
 
 dist:
 	@if test "`git describe`" != "$(VERSION)" ; then \

## sparse 0.4.3+20110419

=== Makefile ===
VERSION=0.4.3

OS = linux


CC = gcc
CFLAGS = -O2 -finline-functions -fno-strict-aliasing -g
CFLAGS += -Wall -Wwrite-strings
LDFLAGS += -g
AR = ar

#
# For debugging, put this in local.mk:
#
#     CFLAGS += -O0 -DDEBUG -g3 -gdwarf-2
#

HAVE_LIBXML:=$(shell pkg-config --exists libxml-2.0 2>/dev/null && echo 'yes')
HAVE_GCC_DEP:=$(shell touch .gcc-test.c && 				\
		$(CC) -c -Wp,-MD,.gcc-test.d .gcc-test.c 2>/dev/null && \
		echo 'yes'; rm -f .gcc-test.d .gcc-test.o .gcc-test.c)
HAVE_GTK2:=$(shell pkg-config --exists gtk+-2.0 2>/dev/null && echo 'yes')

CFLAGS += -DGCC_BASE=\"$(shell $(CC) --print-file-name=)\"

ifeq ($(HAVE_GCC_DEP),yes)
CFLAGS += -Wp,-MD,$(@D)/.$(@F).d
endif

DESTDIR=
PREFIX=$(HOME)
BINDIR=$(PREFIX)/bin
LIBDIR=$(PREFIX)/lib
MANDIR=$(PREFIX)/share/man
MAN1DIR=$(MANDIR)/man1
INCLUDEDIR=$(PREFIX)/include
PKGCONFIGDIR=$(LIBDIR)/pkgconfig

PROGRAMS=test-lexing test-parsing obfuscate compile graph sparse \
	 test-linearize example test-unssa test-dissect ctags
INST_PROGRAMS=sparse cgcc
INST_MAN1=sparse.1 cgcc.1

ifeq ($(HAVE_LIBXML),yes)
PROGRAMS+=c2xml
INST_PROGRAMS+=c2xml
c2xml_EXTRA_OBJS = `pkg-config --libs libxml-2.0`
endif

ifeq ($(HAVE_GTK2),yes)
GTK2_CFLAGS := $(shell pkg-config --cflags gtk+-2.0)
GTK2_LIBS := $(shell pkg-config --libs gtk+-2.0)
PROGRAMS += test-inspect
INST_PROGRAMS += test-inspect
test-inspect_EXTRA_DEPS := ast-model.o ast-view.o ast-inspect.o
test-inspect.o $(test-inspect_EXTRA_DEPS): CFLAGS += $(GTK2_CFLAGS)
test-inspect_EXTRA_OBJS := $(GTK2_LIBS)
endif

LIB_H=    token.h parse.h lib.h symbol.h scope.h expression.h target.h \
	  linearize.h bitmap.h ident-list.h compat.h flow.h allocate.h \
	  storage.h ptrlist.h dissect.h

LIB_OBJS= target.o parse.o tokenize.o pre-process.o symbol.o lib.o scope.o \
	  expression.o show-parse.o evaluate.o expand.o inline.o linearize.o \
	  sort.o allocate.o compat-$(OS).o ptrlist.o \
	  flow.o cse.o simplify.o memops.o liveness.o storage.o unssa.o dissect.o

LIB_FILE= libsparse.a
SLIB_FILE= libsparse.so

# If you add $(SLIB_FILE) to this, you also need to add -fpic to CFLAGS above.
# Doing so incurs a noticeable performance hit, and Sparse does not have a
# stable shared library interface, so this does not occur by default.  If you
# really want a shared library, you may want to build Sparse twice: once
# without -fpic to get all the Sparse tools, and again with -fpic to get the
# shared library.
LIBS=$(LIB_FILE)

#
# Pretty print
#
V	      = @
Q	      = $(V:1=)
QUIET_CC      = $(Q:@=@echo    '     CC       '$@;)
QUIET_AR      = $(Q:@=@echo    '     AR       '$@;)
QUIET_GEN     = $(Q:@=@echo    '     GEN      '$@;)
QUIET_LINK    = $(Q:@=@echo    '     LINK     '$@;)
# We rely on the -v switch of install to print 'file -> $install_dir/file'
QUIET_INST_SH = $(Q:@=echo -n  '     INSTALL  ';)
QUIET_INST    = $(Q:@=@echo -n '     INSTALL  ';)

define INSTALL_EXEC
	$(QUIET_INST)install -v $1 $(DESTDIR)$2/$1 || exit 1;

endef

define INSTALL_FILE
	$(QUIET_INST)install -v -m 644 $1 $(DESTDIR)$2/$1 || exit 1;

endef

SED_PC_CMD = 's|@version@|$(VERSION)|g;		\
	      s|@prefix@|$(PREFIX)|g;		\
	      s|@libdir@|$(LIBDIR)|g;		\
	      s|@includedir@|$(INCLUDEDIR)|g'



# Allow users to override build settings without dirtying their trees
-include local.mk


all: $(PROGRAMS) sparse.pc

install: $(INST_PROGRAMS) $(LIBS) $(LIB_H) sparse.pc
	$(Q)install -d $(DESTDIR)$(BINDIR)
	$(Q)install -d $(DESTDIR)$(LIBDIR)
	$(Q)install -d $(DESTDIR)$(MAN1DIR)
	$(Q)install -d $(DESTDIR)$(INCLUDEDIR)/sparse
	$(Q)install -d $(DESTDIR)$(PKGCONFIGDIR)
	$(foreach f,$(INST_PROGRAMS),$(call INSTALL_EXEC,$f,$(BINDIR)))
	$(foreach f,$(INST_MAN1),$(call INSTALL_FILE,$f,$(MAN1DIR)))
	$(foreach f,$(LIBS),$(call INSTALL_FILE,$f,$(LIBDIR)))
	$(foreach f,$(LIB_H),$(call INSTALL_FILE,$f,$(INCLUDEDIR)/sparse))
	$(call INSTALL_FILE,sparse.pc,$(PKGCONFIGDIR))

sparse.pc: sparse.pc.in
	$(QUIET_GEN)sed $(SED_PC_CMD) sparse.pc.in > sparse.pc


compile_EXTRA_DEPS = compile-i386.o

$(foreach p,$(PROGRAMS),$(eval $(p): $($(p)_EXTRA_DEPS) $(LIBS)))
$(PROGRAMS): % : %.o 
	$(QUIET_LINK)$(CC) $(LDFLAGS) -o $@ $^ $($@_EXTRA_OBJS) 

$(LIB_FILE): $(LIB_OBJS)
	$(QUIET_AR)$(AR) rcs $@ $(LIB_OBJS)

$(SLIB_FILE): $(LIB_OBJS)
	$(QUIET_LINK)$(CC) $(LDFLAGS) -Wl,-soname,$@ -shared -o $@ $(LIB_OBJS)

DEP_FILES := $(wildcard .*.o.d)
$(if $(DEP_FILES),$(eval include $(DEP_FILES)))

c2xml.o: c2xml.c $(LIB_H)
	$(QUIET_CC)$(CC) `pkg-config --cflags libxml-2.0` -o $@ -c $(CFLAGS) $<

compat-linux.o: compat/strtold.c compat/mmap-blob.c $(LIB_H)
compat-solaris.o: compat/mmap-blob.c $(LIB_H)
compat-mingw.o: $(LIB_H)
compat-cygwin.o: $(LIB_H)

%.o: %.c
	$(QUIET_CC)$(CC) -o $@ -c $(CFLAGS) $<

clean: clean-check
	rm -f *.[oa] .*.d *.so $(PROGRAMS) $(SLIB_FILE) pre-process.h sparse.pc

dist:
	@if test "`git describe`" != "v$(VERSION)" ; then \
		echo 'Update VERSION in the Makefile before running "make dist".' ; \
		exit 1 ; \
	fi
	git archive --format=tar --prefix=sparse-$(VERSION)/ HEAD^{tree} | gzip -9 > sparse-$(VERSION).tar.gz

check: all
	$(Q)cd validation && ./test-suite

clean-check:
	find validation/ \( -name "*.c.output.expected" \
	                 -o -name "*.c.output.got" \
	                 -o -name "*.c.output.diff" \
	                 -o -name "*.c.error.expected" \
	                 -o -name "*.c.error.got" \
	                 -o -name "*.c.error.diff" \
	                 \) -exec rm {} \;

=== debian/changelog ===
sparse (0.4.3+20110419-1) unstable; urgency=low

  * Merge upstream up to 87f4a7fda3d17:
    + Fixes build with gcc-4.6 (Closes: 625962).

 -- Pierre Habouzit <madcoder@debian.org>  Sat, 07 May 2011 16:26:29 +0200

sparse (0.4.3-1) unstable; urgency=low

  * New upstream release (Closes: #587005):
    + inline forward declarations are now allowed (Closes: #607432).
  * Update Homepage (Closes: #566605).
  * Bump standards versions to 3.9.1.
  * Switch from cdbs to debhelper.
  * Add libxml2-dev and libgtk2.0-dev to build-depends to build new tools
    (Closes: #608592).

 -- Pierre Habouzit <madcoder@debian.org>  Sat, 19 Mar 2011 20:26:16 +0100

sparse (0.4.1-1) unstable; urgency=low

  * New upstreal release.
  * (debian/control):
      + rename XS-VCS-* headers into VCS-*.
      + have a real Homepage header.

 -- Pierre Habouzit <madcoder@debian.org>  Sun, 18 Nov 2007 09:33:43 +0100

sparse (0.4-2) unstable; urgency=low

  * Upload to unstable.

 -- Pierre Habouzit <madcoder@debian.org>  Fri, 12 Oct 2007 10:11:58 +0200

sparse (0.4-1) experimental; urgency=low

  * New upstream release: closes: #426143, #444879:
      + (debian/copyright): update copyrights.
  * Take over maintainance with permission from Loïc.
  * (debian/control):
      + add XS-Vcs-* headers.
      + add XS-autobuild: Yes.
  * (debian/sparse.manpages): install cgcc.1, sparse.1.

 -- Pierre Habouzit <madcoder@debian.org>  Wed, 10 Oct 2007 00:55:55 +0200

sparse (0.3-1) experimental; urgency=low

  * New upstream release.
    - Fixes usage of prefix versus DESTDIR in sparse.pc; closes: #404399.
    - Pass PREFIX to all make invocations.
    - Update path to pkg-config file.
  * Set CFLAGS manually in debian/rules for the upstream build until it
    permits passing additional CFLAGS; thanks Pierre Habouzit;
    closes: #422896.
  * Update homepage; add Homepage field to Description.
  * Workaround bogus upstream version by passing the upstream version computed
    by CDBS to the upstream build.

 -- Loic Minier <lool@dooz.org>  Fri, 25 May 2007 18:05:17 +0200

sparse (0.2-2) experimental; urgency=low

  * Ship FAQ.

 -- Loic Minier <lool@dooz.org>  Thu,  7 Dec 2006 21:59:18 +0100

sparse (0.2-1) experimental; urgency=low

  * New upstream release.
    - Update vars for new upstream Makefile (which supports DESTDIR).
    - Drop manual bindir creation in build/sparse which isn't needed anymore.
  * Ship pkg-config file.
  * Ship headers and static library.
  * Build and ship shared library.

 -- Loic Minier <lool@dooz.org>  Thu,  7 Dec 2006 17:27:13 +0100

sparse (0.1-1) experimental; urgency=low

  * Initial release; closes: #397780.

 -- Loic Minier <lool@dooz.org>  Thu,  9 Nov 2006 13:09:59 +0100

=== debian/control ===
Source: sparse
Maintainer: Pierre Habouzit <madcoder@debian.org>
Uploaders: Loic Minier <lool@dooz.org>
Section: non-free/devel
Priority: optional
Build-Depends: debhelper (>= 8), libxml2-dev, libgtk2.0-dev
Standards-Version: 3.9.1
Vcs-Git: git://git.debian.org/git/collab-maint/sparse.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/sparse.git
XS-autobuild: yes

Package: sparse
Architecture: any
Section: non-free/devel
Priority: optional
Depends: ${misc:Depends}, ${shlibs:Depends}
Homepage: http://sparse.wiki.kernel.org/index.php/Main_Page
Description: semantic parser of source files
 Sparse, the semantic parser, provides a compiler frontend capable of
 parsing most of ANSI C as well as many GCC extensions, and a collection
 of sample compiler backends, including a static analyzer also called
 "sparse". Sparse provides a set of annotations designed to convey
 semantic information about types, such as what address space pointers
 point to, or what locks a function acquires or releases.
 .
 Sparse can be invoked directly as "sparse" or via the "cgcc" wrapper
 around the C compiler.

## sparse 0.4.5~rc1

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,12 @@
-VERSION=0.4.3
+VERSION=0.4.4
+
+# Generating file version.h if current version has changed
+SPARSE_VERSION:=$(shell git describe 2>/dev/null || echo '$(VERSION)')
+VERSION_H := $(shell cat version.h 2>/dev/null)
+ifneq ($(lastword $(VERSION_H)),"$(SPARSE_VERSION)")
+$(info $(shell echo '     GEN      'version.h))
+$(shell echo '#define SPARSE_VERSION "$(SPARSE_VERSION)"' > version.h)
+endif
 
 OS = linux
 
@@ -7,8 +15,10 @@
 CFLAGS = -O2 -finline-functions -fno-strict-aliasing -g
 CFLAGS += -Wall -Wwrite-strings
 LDFLAGS += -g
+LD = gcc
 AR = ar
 
+ALL_CFLAGS = $(CFLAGS) $(BASIC_CFLAGS)
 #
 # For debugging, put this in local.mk:
 #
@@ -20,11 +30,15 @@
 		$(CC) -c -Wp,-MD,.gcc-test.d .gcc-test.c 2>/dev/null && \
 		echo 'yes'; rm -f .gcc-test.d .gcc-test.o .gcc-test.c)
 HAVE_GTK2:=$(shell pkg-config --exists gtk+-2.0 2>/dev/null && echo 'yes')
-
-CFLAGS += -DGCC_BASE=\"$(shell $(CC) --print-file-name=)\"
+HAVE_LLVM:=$(shell llvm-config --version >/dev/null 2>&1 && echo 'yes')
+HAVE_LLVM_VERSION:=$(shell llvm-config --version | grep "^[3-9].*" >/dev/null 2>&1 && echo yes)
+LLVM_VERSION=$(shell llvm-config --version)
+
+GCC_BASE = $(shell $(CC) --print-file-name=)
+BASIC_CFLAGS = -DGCC_BASE=\"$(GCC_BASE)\"
 
 ifeq ($(HAVE_GCC_DEP),yes)
-CFLAGS += -Wp,-MD,$(@D)/.$(@F).d
+BASIC_CFLAGS += -Wp,-MD,$(@D)/.$(@F).d
 endif
 
 DESTDIR=
@@ -45,6 +59,8 @@
 PROGRAMS+=c2xml
 INST_PROGRAMS+=c2xml
 c2xml_EXTRA_OBJS = `pkg-config --libs libxml-2.0`
+else
+$(warning Your system does not have libxml, disabling c2xml)
 endif
 
 ifeq ($(HAVE_GTK2),yes)
@@ -53,8 +69,30 @@
 PROGRAMS += test-inspect
 INST_PROGRAMS += test-inspect
 test-inspect_EXTRA_DEPS := ast-model.o ast-view.o ast-inspect.o
-test-inspect.o $(test-inspect_EXTRA_DEPS): CFLAGS += $(GTK2_CFLAGS)
+test-inspect.o $(test-inspect_EXTRA_DEPS): BASIC_CFLAGS += $(GTK2_CFLAGS)
 test-inspect_EXTRA_OBJS := $(GTK2_LIBS)
+else
+$(warning Your system does not have libgtk2, disabling test-inspect)
+endif
+
+ifneq ($(HAVE_LLVM),yes)
+$(warning Your system does not have llvm, disabling sparse-llvm)
+else
+ifneq ($(HAVE_LLVM_VERSION),yes)
+$(warning LLVM 3.0 or later required. Your system has version $(LLVM_VERSION) installed.)
+HAVE_LLVM=no
+else
+LLVM_PROGS := sparse-llvm
+$(LLVM_PROGS): LD := g++
+LDFLAGS += $(shell llvm-config --ldflags)
+LLVM_CFLAGS := $(shell llvm-config --cflags | sed -e "s/-DNDEBUG//g")
+LLVM_LIBS := $(shell llvm-config --libs)
+PROGRAMS += $(LLVM_PROGS)
+INST_PROGRAMS += sparse-llvm sparsec
+sparse-llvm_EXTRA_DEPS := sparse-llvm.o
+sparse-llvm.o $(sparse-llvm_EXTRA_DEPS): BASIC_CFLAGS += $(LLVM_CFLAGS)
+sparse-llvm_EXTRA_OBJS := $(LLVM_LIBS)
+endif
 endif
 
 LIB_H=    token.h parse.h lib.h symbol.h scope.h expression.h target.h \
@@ -63,13 +101,13 @@
 
 LIB_OBJS= target.o parse.o tokenize.o pre-process.o symbol.o lib.o scope.o \
 	  expression.o show-parse.o evaluate.o expand.o inline.o linearize.o \
-	  sort.o allocate.o compat-$(OS).o ptrlist.o \
+	  char.o sort.o allocate.o compat-$(OS).o ptrlist.o \
 	  flow.o cse.o simplify.o memops.o liveness.o storage.o unssa.o dissect.o
 
 LIB_FILE= libsparse.a
 SLIB_FILE= libsparse.so
 
-# If you add $(SLIB_FILE) to this, you also need to add -fpic to CFLAGS above.
+# If you add $(SLIB_FILE) to this, you also need to add -fpic to BASIC_CFLAGS above.
 # Doing so incurs a noticeable performance hit, and Sparse does not have a
 # stable shared library interface, so this does not occur by default.  If you
 # really want a shared library, you may want to build Sparse twice: once
@@ -113,7 +151,9 @@
 
 all: $(PROGRAMS) sparse.pc
 
-install: $(INST_PROGRAMS) $(LIBS) $(LIB_H) sparse.pc
+all-installable: $(INST_PROGRAMS) $(LIBS) $(LIB_H) sparse.pc
+
+install: all-installable
 	$(Q)install -d $(DESTDIR)$(BINDIR)
 	$(Q)install -d $(DESTDIR)$(LIBDIR)
 	$(Q)install -d $(DESTDIR)$(MAN1DIR)
@@ -133,7 +173,7 @@
 
 $(foreach p,$(PROGRAMS),$(eval $(p): $($(p)_EXTRA_DEPS) $(LIBS)))
 $(PROGRAMS): % : %.o 
-	$(QUIET_LINK)$(CC) $(LDFLAGS) -o $@ $^ $($@_EXTRA_OBJS) 
+	$(QUIET_LINK)$(LD) $(LDFLAGS) -o $@ $^ $($@_EXTRA_OBJS)
 
 $(LIB_FILE): $(LIB_OBJS)
 	$(QUIET_AR)$(AR) rcs $@ $(LIB_OBJS)
@@ -145,7 +185,7 @@
 $(if $(DEP_FILES),$(eval include $(DEP_FILES)))
 
 c2xml.o: c2xml.c $(LIB_H)
-	$(QUIET_CC)$(CC) `pkg-config --cflags libxml-2.0` -o $@ -c $(CFLAGS) $<
+	$(QUIET_CC)$(CC) `pkg-config --cflags libxml-2.0` -o $@ -c $(ALL_CFLAGS) $<
 
 compat-linux.o: compat/strtold.c compat/mmap-blob.c $(LIB_H)
 compat-solaris.o: compat/mmap-blob.c $(LIB_H)
@@ -153,13 +193,13 @@
 compat-cygwin.o: $(LIB_H)
 
 %.o: %.c
-	$(QUIET_CC)$(CC) -o $@ -c $(CFLAGS) $<
+	$(QUIET_CC)$(CC) -o $@ -c $(ALL_CFLAGS) $<
 
 clean: clean-check
 	rm -f *.[oa] .*.d *.so $(PROGRAMS) $(SLIB_FILE) pre-process.h sparse.pc
 
 dist:
-	@if test "`git describe`" != "v$(VERSION)" ; then \
+	@if test "v$(SPARSE_VERSION)" != "v$(VERSION)" ; then \
 		echo 'Update VERSION in the Makefile before running "make dist".' ; \
 		exit 1 ; \
 	fi

=== debian/changelog ===
sparse (0.4.5~rc1-1) unstable; urgency=low

  [ Uwe Kleine-König ]
  * new upstream release candidate
  * switch to debhelper 9 to get hardend binaries
  * Standards-Version: 3.9.4 (no changes needed)
  * Add patch to add --as-needed to LDFLAGS (except for LLVM).
  * Add missing ${perl:Depends}.

  [ Loïc Minier ]
  * Use my Debian address in control.
  * Update Vcs fields to use anonscm URLs.
  * Don't repeat Section and Priority in binary package stanza.
  * Fix typo in copyright file.
  * Add watch file.
  * Build sparse-llvm by adding llvm-dev (>= 3.0~) build-dep.
  * Add patch to pass CFLAGS and CPPFLAGS from rules to Makefile, notably
    hardening flags.

 -- Loïc Minier <lool@debian.org>  Sat, 15 Jun 2013 01:06:33 +0200

=== debian/control ===
--- 
+++ 
@@ -1,19 +1,20 @@
 Source: sparse
 Maintainer: Pierre Habouzit <madcoder@debian.org>
-Uploaders: Loic Minier <lool@dooz.org>
+Uploaders: Loïc Minier <lool@debian.org>
 Section: non-free/devel
 Priority: optional
-Build-Depends: debhelper (>= 8), libxml2-dev, libgtk2.0-dev
-Standards-Version: 3.9.1
-Vcs-Git: git://git.debian.org/git/collab-maint/sparse.git
-Vcs-Browser: http://git.debian.org/?p=collab-maint/sparse.git
+Build-Depends: debhelper (>= 9),
+               libxml2-dev,
+               libgtk2.0-dev,
+               llvm-dev (>= 1:3.0~)
+Standards-Version: 3.9.4
+Vcs-Git: git://anonscm.debian.org/collab-maint/sparse.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/sparse.git
 XS-autobuild: yes
 
 Package: sparse
 Architecture: any
-Section: non-free/devel
-Priority: optional
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}, ${perl:Depends}
 Homepage: http://sparse.wiki.kernel.org/index.php/Main_Page
 Description: semantic parser of source files
  Sparse, the semantic parser, provides a compiler frontend capable of

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_install:
	$(MAKE) install PREFIX=/usr DESTDIR=debian/sparse

=== debian/watch ===
version=3
https://www.kernel.org/pub/software/devel/sparse/dist/ \
  sparse-([\d\.]+)\.tar\.bz2 \
  debian uupdate

## sparse 0.5.0

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-VERSION=0.4.4
+VERSION=0.5.0
 
 # Generating file version.h if current version has changed
 SPARSE_VERSION:=$(shell git describe 2>/dev/null || echo '$(VERSION)')
@@ -84,14 +84,13 @@
 else
 LLVM_PROGS := sparse-llvm
 $(LLVM_PROGS): LD := g++
-LDFLAGS += $(shell llvm-config --ldflags)
+LLVM_LDFLAGS := $(shell llvm-config --ldflags)
 LLVM_CFLAGS := $(shell llvm-config --cflags | sed -e "s/-DNDEBUG//g")
 LLVM_LIBS := $(shell llvm-config --libs)
 PROGRAMS += $(LLVM_PROGS)
 INST_PROGRAMS += sparse-llvm sparsec
-sparse-llvm_EXTRA_DEPS := sparse-llvm.o
-sparse-llvm.o $(sparse-llvm_EXTRA_DEPS): BASIC_CFLAGS += $(LLVM_CFLAGS)
-sparse-llvm_EXTRA_OBJS := $(LLVM_LIBS)
+sparse-llvm.o: BASIC_CFLAGS += $(LLVM_CFLAGS)
+sparse-llvm_EXTRA_OBJS := $(LLVM_LIBS) $(LLVM_LDFLAGS)
 endif
 endif
 
@@ -199,7 +198,7 @@
 	rm -f *.[oa] .*.d *.so $(PROGRAMS) $(SLIB_FILE) pre-process.h sparse.pc
 
 dist:
-	@if test "v$(SPARSE_VERSION)" != "v$(VERSION)" ; then \
+	@if test "$(SPARSE_VERSION)" != "v$(VERSION)" ; then \
 		echo 'Update VERSION in the Makefile before running "make dist".' ; \
 		exit 1 ; \
 	fi

=== debian/changelog ===
sparse (0.5.0-4) unstable; urgency=medium

  * Upload to unstable

 -- Uwe Kleine-König <ukleinek@debian.org>  Sat, 12 Aug 2017 22:45:58 +0200

sparse (0.5.0-3) experimental; urgency=medium

  * Add Breaks: and Replaces: to sparse-test-inspect as required by package
    split in 0.5.0-2. (Closes: #863966)

 -- Uwe Kleine-König <ukleinek@debian.org>  Fri, 02 Jun 2017 14:42:55 +0200

sparse (0.5.0-2) experimental; urgency=medium

  * Split package to have test-inspect in a separate package. This allows to
    install sparse without having to install tons of GTK+ and Gnome libs.
    Patch by W. Martin Borgert (Closes: #845626)
  * Cherry-pick two commits from upstream fixing false warnings about IS_ERR
    when checking the kernel sources. (Closes: #862319)

 -- Uwe Kleine-König <ukleinek@debian.org>  Thu, 11 May 2017 10:56:10 +0200

sparse (0.5.0-1) unstable; urgency=medium

  * new upstream release (Closes: #743923)
    - upstream relicensed under MIT (Closes: #524319)
  * provide PREFIX already at build time (Closes: #660274)
  * Standards-Version: 3.9.6 (no changes needed) 
  * Merge 0.4.5~rc1-2, thanks to Andreas Beckmann 
  * Take over maintenance, drop Loïc from Uploaders (Closes: #794643)
  * cherry-pick patches from upstream to make sparse multi-arch aware
    (Closes: #755979)

 -- Uwe Kleine-König <ukleinek@debian.org>  Tue, 03 Nov 2015 00:43:13 +0100

sparse (0.4.5~rc1-2~deb8u1) jessie; urgency=medium

  * QA upload.
  * Rebuild for jessie.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 09 Sep 2015 22:28:16 +0200

sparse (0.4.5~rc1-2) unstable; urgency=medium

  [ Andreas Beckmann ]
  * QA upload.
  * Set maintainer to Debian QA Group.  (See #794643)
  * Fix Homepage and Vcs-Browser URLs.
  * Refresh patch to apply without fuzz.

  [ Uwe Kleine-König ]
  * Cherry-pick commit from upstream to fix build failure with llvm-3.5.
  * Temporarily build-depend on libedit-dev because llvm-config claims to need
    that.  (Closes: #793197)

 -- Andreas Beckmann <anbe@debian.org>  Sat, 08 Aug 2015 13:17:27 +0200

=== debian/control ===
Source: sparse
Maintainer: Uwe Kleine-König <ukleinek@debian.org>
Section: devel
Priority: optional
Build-Depends: debhelper (>= 9),
               libxml2-dev,
               libgtk2.0-dev,
               llvm-dev (>= 1:3.0~),
               libedit-dev
Standards-Version: 3.9.6
Vcs-Git: git://anonscm.debian.org/collab-maint/sparse.git
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/sparse.git
Homepage: https://sparse.wiki.kernel.org/

Package: sparse
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, ${perl:Depends}
Suggests: sparse-test-inspect
Description: semantic parser of source files
 Sparse, the semantic parser, provides a compiler frontend capable of
 parsing most of ANSI C as well as many GCC extensions, and a collection
 of sample compiler backends, including a static analyzer also called
 "sparse". Sparse provides a set of annotations designed to convey
 semantic information about types, such as what address space pointers
 point to, or what locks a function acquires or releases.
 .
 Sparse can be invoked directly as "sparse" or via the "cgcc" wrapper
 around the C compiler.

Package: sparse-test-inspect
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: sparse (<< 0.5.0-2)
Replaces: sparse (<< 0.5.0-2)
Description: semantic parser of source files
 Sparse, the semantic parser, provides a compiler frontend capable of
 parsing most of ANSI C as well as many GCC extensions, and a collection
 of sample compiler backends, including a static analyzer also called
 "sparse". Sparse provides a set of annotations designed to convey
 semantic information about types, such as what address space pointers
 point to, or what locks a function acquires or releases.
 .
 This package contains the test-inspect program.

=== debian/rules ===
#!/usr/bin/make -f

export PREFIX=/usr

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- V=1

override_dh_auto_test:
	dh_auto_test -- V=1

override_dh_auto_install:
	dh_auto_install -- V=1

## sparse 0.5.1

=== debian/changelog ===
sparse (0.5.1-2) unstable; urgency=medium

  * Note Debian package version in sparse's version string
  * Fix Vcs URL to not use an insecure URI
  * Switch to debhelper 10
  * Provide a patch description for the last patch lacking one
  * new patch to fix FTBFS on armhf

 -- Uwe Kleine-König <ukleinek@debian.org>  Tue, 26 Sep 2017 09:42:03 +0200

sparse (0.5.1-1) unstable; urgency=medium

  * New upstream release
  * Additional patch from upstream:
    - 23a393b1cd48 ("Sparse preprocessing bug with zero-arg variadic macros")
    - 2093505d7b70 ("compile-i386.c: fix a memory leak in sort_array()")
    - f1e4ba13d149 ("build: disable sparse-llvm on non-x86")
  * Disable llvm on !x86
  * Update debian/watch to look at git.kernel.org instead of the download
    directory (which wasn't used for the last release).
  * Standards-Version: 4.1.0 (no changes needed)
  * new patch to improve handling of autogenerated version.h
  * Drop Build-Depends: libedit-dev which was ony added as a work around
    as llvm-config --libs issued -ledit.

 -- Uwe Kleine-König <ukleinek@debian.org>  Fri, 22 Sep 2017 09:04:19 +0200

=== debian/control ===
--- 
+++ 
@@ -2,14 +2,13 @@
 Maintainer: Uwe Kleine-König <ukleinek@debian.org>
 Section: devel
 Priority: optional
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper (>= 10),
                libxml2-dev,
                libgtk2.0-dev,
-               llvm-dev (>= 1:3.0~),
-               libedit-dev
-Standards-Version: 3.9.6
-Vcs-Git: git://anonscm.debian.org/collab-maint/sparse.git
-Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/sparse.git
+               llvm-dev (>= 1:3.0~) [amd64 i386],
+Standards-Version: 4.1.0
+Vcs-Git: https://anonscm.debian.org/git/collab-maint/sparse.git
+Vcs-Browser: https://anonscm.debian.org/git/collab-maint/sparse.git
 Homepage: https://sparse.wiki.kernel.org/
 
 Package: sparse

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/vendor.mk

DH_MAKE_ARGS = V=1 SPARSE_VERSION="\$$(VERSION) ($(DEB_VENDOR): $(DEB_VERSION))" PREFIX=/usr

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- $(DH_MAKE_ARGS)

override_dh_auto_test:
	dh_auto_test -- $(DH_MAKE_ARGS)
# test for missing cpp symbols to compile hosted programs
	env CHECK=./sparse ./cgcc -no-compile memops.c

override_dh_auto_install:
	dh_auto_install -- $(DH_MAKE_ARGS)

## sparse 0.5.2

=== debian/changelog ===
sparse (0.5.2-1) unstable; urgency=medium

  * New upstream release (Closes: #895598)
    - cc58fdcfb856 ("fix cgcc ELF version for ppc64/pcc64le") fixed the build
      on ppc64
    - Since 9d58bbdf7865 ("Makefile: provide CFLAGS for command line
      override.") patch pass-down-cflags isn't needed any more and so was
      dropped. Added a simpler patch to honor CPPFLAGS.
    - several patches are included and were dropped accordingly:
      - 23a393b1cd48 ("Sparse preprocessing bug with zero-arg variadic macros")
      - f1e4ba13d149 ("build: disable sparse-llvm on non-x86")
      - 4b7b6b63f606 ("cgcc: provide __ARM_PCS_VFP for armhf")
      - 57efc7462a88 ("cgcc: teach cgcc about GNU/kFreeBSD")
      - 2093505d7b70 ("compile-i386.c: fix a memory leak in sort_array()")
  * move sparse.pc to /usr/lib/${DEB_HOST_MULTIARCH}/pkgconfig/
  * Bump standards versions to 4.1.4 (no changes necessary)

 -- Uwe Kleine-König <ukleinek@debian.org>  Thu, 19 Apr 2018 17:50:13 +0000

=== debian/control ===
--- 
+++ 
@@ -6,9 +6,9 @@
                libxml2-dev,
                libgtk2.0-dev,
                llvm-dev (>= 1:3.0~) [amd64 i386],
-Standards-Version: 4.1.0
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/sparse.git
-Vcs-Browser: https://anonscm.debian.org/git/collab-maint/sparse.git
+Standards-Version: 4.1.4
+Vcs-Git: https://salsa.debian.org/ukleinek/sparse.git
+Vcs-Browser: https://salsa.debian.org/ukleinek/sparse
 Homepage: https://sparse.wiki.kernel.org/
 
 Package: sparse

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/vendor.mk

DH_MAKE_ARGS = V=1 SPARSE_VERSION="\$$(VERSION) ($(DEB_VENDOR): $(DEB_VERSION))" PREFIX=/usr PKGCONFIGDIR=/usr/lib/${DEB_HOST_MULTIARCH}/pkgconfig

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- $(DH_MAKE_ARGS)

override_dh_auto_test:
	dh_auto_test -- $(DH_MAKE_ARGS)
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
# test for missing cpp symbols to compile hosted programs
	env CHECK=./sparse ./cgcc -no-compile memops.c
endif

override_dh_auto_install:
	dh_auto_install -- $(DH_MAKE_ARGS)

## sparse 0.6.0

=== Makefile ===
VERSION=0.6.0

########################################################################
# The following variables can be overwritten from the command line
OS = linux


CC = gcc
CFLAGS = -O2 -g
CFLAGS += -Wall -Wwrite-strings
LD = gcc
AR = ar
PKG_CONFIG = pkg-config
CHECKER = CHECK=./sparse ./cgcc -no-compile
CHECKER_FLAGS = -Wno-vla

DESTDIR=
PREFIX ?= $(HOME)
BINDIR=$(PREFIX)/bin
MANDIR=$(PREFIX)/share/man
MAN1DIR=$(MANDIR)/man1

# Allow users to override build settings without dirtying their trees
# For debugging, put this in local.mk:
#
#     CFLAGS += -O0 -DDEBUG -g3 -gdwarf-2
#
SPARSE_LOCAL_CONFIG ?= local.mk
-include ${SPARSE_LOCAL_CONFIG}
########################################################################


LIB_OBJS :=
LIB_OBJS += allocate.o
LIB_OBJS += builtin.o
LIB_OBJS += char.o
LIB_OBJS += compat-$(OS).o
LIB_OBJS += cse.o
LIB_OBJS += dissect.o
LIB_OBJS += dominate.o
LIB_OBJS += evaluate.o
LIB_OBJS += expand.o
LIB_OBJS += expression.o
LIB_OBJS += flow.o
LIB_OBJS += flowgraph.o
LIB_OBJS += inline.o
LIB_OBJS += ir.o
LIB_OBJS += lib.o
LIB_OBJS += linearize.o
LIB_OBJS += liveness.o
LIB_OBJS += memops.o
LIB_OBJS += opcode.o
LIB_OBJS += optimize.o
LIB_OBJS += parse.o
LIB_OBJS += pre-process.o
LIB_OBJS += ptrlist.o
LIB_OBJS += ptrmap.o
LIB_OBJS += scope.o
LIB_OBJS += show-parse.o
LIB_OBJS += simplify.o
LIB_OBJS += sort.o
LIB_OBJS += ssa.o
LIB_OBJS += sset.o
LIB_OBJS += stats.o
LIB_OBJS += storage.o
LIB_OBJS += symbol.o
LIB_OBJS += target.o
LIB_OBJS += tokenize.o
LIB_OBJS += unssa.o
LIB_OBJS += utils.o

PROGRAMS :=
PROGRAMS += compile
PROGRAMS += ctags
PROGRAMS += example
PROGRAMS += graph
PROGRAMS += obfuscate
PROGRAMS += sparse
PROGRAMS += test-dissect
PROGRAMS += test-lexing
PROGRAMS += test-linearize
PROGRAMS += test-parsing
PROGRAMS += test-unssa

INST_PROGRAMS=sparse cgcc
INST_MAN1=sparse.1 cgcc.1


all:

########################################################################
# common flags/options/...

cflags = -fno-strict-aliasing

GCC_BASE := $(shell $(CC) --print-file-name=)
cflags += -DGCC_BASE=\"$(GCC_BASE)\"

MULTIARCH_TRIPLET := $(shell $(CC) -print-multiarch 2>/dev/null)
cflags += -DMULTIARCH_TRIPLET=\"$(MULTIARCH_TRIPLET)\"

########################################################################
# target specificities

compile: compile-i386.o
EXTRA_OBJS += compile-i386.o

# Can we use GCC's generated dependencies?
HAVE_GCC_DEP:=$(shell touch .gcc-test.c && 				\
		$(CC) -c -Wp,-MP,-MMD,.gcc-test.d .gcc-test.c 2>/dev/null && \
		echo 'yes'; rm -f .gcc-test.d .gcc-test.o .gcc-test.c)
ifeq ($(HAVE_GCC_DEP),yes)
cflags += -Wp,-MP,-MMD,$(@D)/.$(@F).d
endif

# Can we use libxml (needed for c2xml)?
HAVE_LIBXML:=$(shell $(PKG_CONFIG) --exists libxml-2.0 2>/dev/null && echo 'yes')
ifeq ($(HAVE_LIBXML),yes)
PROGRAMS+=c2xml
INST_PROGRAMS+=c2xml
c2xml-ldlibs := $(shell $(PKG_CONFIG) --libs libxml-2.0)
c2xml-cflags := $(shell $(PKG_CONFIG) --cflags libxml-2.0)
else
$(warning Your system does not have libxml, disabling c2xml)
endif

# Can we use gtk (needed for test-inspect)
GTK_VERSION:=3.0
HAVE_GTK:=$(shell $(PKG_CONFIG) --exists gtk+-$(GTK_VERSION) 2>/dev/null && echo 'yes')
ifneq ($(HAVE_GTK),yes)
GTK_VERSION:=2.0
HAVE_GTK:=$(shell $(PKG_CONFIG) --exists gtk+-$(GTK_VERSION) 2>/dev/null && echo 'yes')
endif
ifeq ($(HAVE_GTK),yes)
GTK_CFLAGS := $(shell $(PKG_CONFIG) --cflags gtk+-$(GTK_VERSION))
ast-view-cflags := $(GTK_CFLAGS)
ast-model-cflags := $(GTK_CFLAGS)
ast-inspect-cflags := $(GTK_CFLAGS)
test-inspect-cflags := $(GTK_CFLAGS)
test-inspect-ldlibs := $(shell $(PKG_CONFIG) --libs gtk+-$(GTK_VERSION))
test-inspect: ast-model.o ast-view.o ast-inspect.o
EXTRA_OBJS += ast-model.o ast-view.o ast-inspect.o
PROGRAMS += test-inspect
INST_PROGRAMS += test-inspect
else
$(warning Your system does not have gtk3/gtk2, disabling test-inspect)
endif

# Can we use LLVM (needed for ... sparse-llvm)?
LLVM_CONFIG:=llvm-config
HAVE_LLVM:=$(shell $(LLVM_CONFIG) --version >/dev/null 2>&1 && echo 'yes')
ifeq ($(HAVE_LLVM),yes)
arch := $(shell uname -m)
ifeq (${MULTIARCH_TRIPLET},x86_64-linux-gnux32)
arch := x32
endif
ifneq ($(filter ${arch},i386 i486 i586 i686 x86_64 amd64),)
LLVM_VERSION:=$(shell $(LLVM_CONFIG) --version)
ifeq ($(shell expr "$(LLVM_VERSION)" : '[3-9]\.'),2)
LLVM_PROGS := sparse-llvm
$(LLVM_PROGS): LD := g++
LLVM_LDFLAGS := $(shell $(LLVM_CONFIG) --ldflags)
LLVM_CFLAGS := -I$(shell $(LLVM_CONFIG) --includedir)
LLVM_LIBS := $(shell $(LLVM_CONFIG) --libs)
LLVM_LIBS += $(shell $(LLVM_CONFIG) --system-libs 2>/dev/null)
LLVM_LIBS += $(shell $(LLVM_CONFIG) --cxxflags | grep -F -q -e '-stdlib=libc++' && echo -lc++)
PROGRAMS += $(LLVM_PROGS)
INST_PROGRAMS += sparse-llvm sparsec
sparse-llvm-cflags := $(LLVM_CFLAGS)
sparse-llvm-ldflags := $(LLVM_LDFLAGS)
sparse-llvm-ldlibs := $(LLVM_LIBS)
else
$(warning LLVM 3.0 or later required. Your system has version $(LLVM_VERSION) installed.)
endif
else
$(warning sparse-llvm disabled on ${arch})
endif
else
$(warning Your system does not have llvm, disabling sparse-llvm)
endif

########################################################################
LIBS := libsparse.a
OBJS := $(LIB_OBJS) $(EXTRA_OBJS) $(PROGRAMS:%=%.o)

# Pretty print
V := @
Q := $(V:1=)

########################################################################
all: $(PROGRAMS)

ldflags += $($(@)-ldflags) $(LDFLAGS)
ldlibs  += $($(@)-ldlibs)  $(LDLIBS)
$(PROGRAMS): % : %.o $(LIBS)
	@echo "  LD      $@"
	$(Q)$(LD) $(ldflags) $^ $(ldlibs) -o $@

libsparse.a: $(LIB_OBJS)
	@echo "  AR      $@"
	$(Q)$(AR) rcs $@ $^


cflags   += $($(*)-cflags) $(CPPFLAGS) $(CFLAGS)
%.o: %.c
	@echo "  CC      $@"
	$(Q)$(CC) $(cflags) -c -o $@ $<

%.sc: %.c sparse
	@echo "  CHECK   $<"
	$(Q) $(CHECKER) $(CHECKER_FLAGS) $(cflags) -c $<

selfcheck: $(OBJS:.o=.sc)


SPARSE_VERSION:=$(shell git describe --dirty 2>/dev/null || echo '$(VERSION)')
lib.o: version.h
version.h: FORCE
	@echo '#define SPARSE_VERSION "$(SPARSE_VERSION)"' > version.h.tmp
	@if cmp -s version.h version.h.tmp; then \
		rm version.h.tmp; \
	else \
		echo "  GEN     $@"; \
		mv version.h.tmp version.h; \
	fi


check: all
	$(Q)cd validation && ./test-suite
validation/%.t: $(PROGRAMS)
	@validation/test-suite single $*.c


clean: clean-check
	@rm -f *.[oa] .*.d $(PROGRAMS) version.h
clean-check:
	@echo "  CLEAN"
	@find validation/ \( -name "*.c.output.*" \
			  -o -name "*.c.error.*" \
			  -o -name "*.o" \
	                  \) -exec rm {} \;


install: $(INST_PROGRAMS) $(INST_MAN1) install-dirs install-bin install-man
install-dirs:
	$(Q)install -d $(DESTDIR)$(BINDIR)
	$(Q)install -d $(DESTDIR)$(MAN1DIR)
install-bin: $(INST_PROGRAMS:%=$(DESTDIR)$(BINDIR)/%)
install-man: $(INST_MAN1:%=$(DESTDIR)$(MAN1DIR)/%)

$(DESTDIR)$(BINDIR)/%: %
	@echo "  INSTALL $@"
	$(Q)install        $< $@ || exit 1;
$(DESTDIR)$(MAN1DIR)/%: %
	@echo "  INSTALL $@"
	$(Q)install -m 644 $< $@ || exit 1;

.PHONY: FORCE

# GCC's dependencies
-include $(OBJS:%.o=.%.o.d)

=== debian/changelog ===
sparse (0.6.0-3) unstable; urgency=medium

  * Refresh patches from upstream
  * Fix possible build failure that happend on sparc64 for 0.6.0-2. Patch from
    upstream.
  * New patch to honor CFLAGS from debhelper and so make the build
    reproducible.

 -- Uwe Kleine-König <ukleinek@debian.org>  Tue, 12 Feb 2019 21:42:40 +0100

sparse (0.6.0-2) unstable; urgency=medium

  * New patch to fix FTBFS on m68k
  * New patch to improve grepability for failed tests
  * New patches from upstream to address build failures in 0.6.0-1. Thanks to
    Luc Van Oostenryck. (Closes: #921554)
  * New patch to fix cgcc on mips.

 -- Uwe Kleine-König <ukleinek@debian.org>  Thu, 07 Feb 2019 21:20:33 +0100

sparse (0.6.0-1) unstable; urgency=medium

  * New upstream version (Closes: #920776)
    - Several patches are included and were dropped accordingly
      - 3ff507b6e9e6 ("build: pass CPPFLAGS to compiler")
      - 081679882c3f ("build: add *.o to clean-check pattern")
      - 5844e1713cf6 ("build: only generate version.h when needed")
    - Refresh remaining patches
    - Drop include and pkg-config files as upstream stopped installing them
      (c3490e701eaa ("build: remove unused support for pkgconfig"))
  * Bump standards versions to 4.3.0 (no changes necessary)
  * Switch to debhelper 12

 -- Uwe Kleine-König <ukleinek@debian.org>  Wed, 30 Jan 2019 15:35:42 +0100

sparse (0.5.2-2) unstable; urgency=medium

  * Depend on gcc-8, let cgcc use the versioned compiler command and let
    sparse use gcc-8's include files (Closes: #906472)
  * Support "terse" in DEB_BUILD_OPTIONS
  * Don't require root for building (Rules-Requires-Root: no)
  * Standards-Version: 4.2.1 (no changes needed)

 -- Uwe Kleine-König <ukleinek@debian.org>  Mon, 08 Oct 2018 14:25:04 +0200

=== debian/control ===
--- 
+++ 
@@ -2,18 +2,20 @@
 Maintainer: Uwe Kleine-König <ukleinek@debian.org>
 Section: devel
 Priority: optional
-Build-Depends: debhelper (>= 10),
+Build-Depends: debhelper (>= 12),
+               gcc-8,
                libxml2-dev,
                libgtk2.0-dev,
                llvm-dev (>= 1:3.0~) [amd64 i386],
-Standards-Version: 4.1.4
+Standards-Version: 4.3.0
 Vcs-Git: https://salsa.debian.org/ukleinek/sparse.git
 Vcs-Browser: https://salsa.debian.org/ukleinek/sparse
 Homepage: https://sparse.wiki.kernel.org/
+Rules-Requires-Root: no
 
 Package: sparse
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}, ${perl:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}, ${perl:Depends}, gcc-8
 Suggests: sparse-test-inspect
 Description: semantic parser of source files
  Sparse, the semantic parser, provides a compiler frontend capable of

=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,11 @@
 include /usr/share/dpkg/pkg-info.mk
 include /usr/share/dpkg/vendor.mk
 
-DH_MAKE_ARGS = V=1 SPARSE_VERSION="\$$(VERSION) ($(DEB_VENDOR): $(DEB_VERSION))" PREFIX=/usr PKGCONFIGDIR=/usr/lib/${DEB_HOST_MULTIARCH}/pkgconfig
+DH_MAKE_ARGS = SPARSE_VERSION="\$$(VERSION) ($(DEB_VENDOR): $(DEB_VERSION))" PREFIX=/usr
+
+ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
+DH_MAKE_ARGS += V=1
+endif
 
 %:
 	dh $@
